// DialogDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Dialog.h"
#include "DialogDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CNewDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CNewDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CNewDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CNewDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDialogDlg dialog

CDialogDlg::CDialogDlg(CWnd* pParent /*=NULL*/)
	: CNewDialog(CDialogDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDialogDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDialogDlg::DoDataExchange(CDataExchange* pDX)
{
	CNewDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDialogDlg)
	DDX_Control(pDX, IDC_EDIT1, m_Edit);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDialogDlg, CNewDialog)
	//{{AFX_MSG_MAP(CDialogDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_COMMAND(ID_NEWMENU_NEXTSTYLE, OnNewMenuNextStyle)
	ON_UPDATE_COMMAND_UI(ID_NEWMENU_NEXTSTYLE, OnUpdateNewMenuNextStyle)
	ON_COMMAND(ID_NEWMENU_SHOWSELECTION, OnNewMenuShowSelection)
	ON_UPDATE_COMMAND_UI(ID_NEWMENU_SHOWSELECTION, OnUpdateNewMenuShowSelection)
	ON_COMMAND(ID_NEWMENU_NORMALBORDER, OnNewMenuNormalBorder)
	ON_UPDATE_COMMAND_UI(ID_NEWMENU_NORMALBORDER, OnUpdateNewMenuNormalBorder)
  ON_COMMAND(ID_NEWMENU_ALLMENUSAMEBORDER, OnNewMenuAllSameBorder)
  ON_UPDATE_COMMAND_UI(ID_NEWMENU_ALLMENUSAMEBORDER, OnUpdateNewMenuAllSameBorder)
	//}}AFX_MSG_MAP
	ON_UPDATE_COMMAND_UI(ID_EDIT_CUT, OnUpdateNeedSel)
	ON_UPDATE_COMMAND_UI(ID_EDIT_COPY, OnUpdateNeedSel)
	ON_UPDATE_COMMAND_UI(ID_EDIT_PASTE, OnUpdateNeedClip)
	ON_UPDATE_COMMAND_UI(ID_EDIT_CLEAR, OnUpdateNeedSel)
	ON_UPDATE_COMMAND_UI(ID_EDIT_UNDO, OnUpdateEditUndo)
	ON_UPDATE_COMMAND_UI(ID_EDIT_SELECT_ALL, OnUpdateNeedText)
	ON_COMMAND(ID_EDIT_CUT, OnEditCut)
	ON_COMMAND(ID_EDIT_COPY, OnEditCopy)
	ON_COMMAND(ID_EDIT_PASTE, OnEditPaste)
	ON_COMMAND(ID_EDIT_CLEAR, OnEditClear)
	ON_COMMAND(ID_EDIT_UNDO, OnEditUndo)
	ON_COMMAND(ID_EDIT_SELECT_ALL, OnEditSelectAll)
  ON_BN_CLICKED(IDC_BUTTON1, OnBnClickedButton1)

	ON_COMMAND(ID_NEWMENU_ENABLEGLOOM, OnNewMenuEnableGloom)
	ON_UPDATE_COMMAND_UI(ID_NEWMENU_ENABLEGLOOM, OnUpdateNewMenuEnableGloom)
  ON_UPDATE_COMMAND_UI_RANGE(10000,10500, OnUpdateFileRange) 
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDialogDlg message handlers

BOOL CDialogDlg::OnInitDialog()
{
	CNewDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set a title to the system menu
	m_SystemNewMenu.SetMenuTitle(_T("New Menu Sample"),MFT_GRADIENT|MFT_LINE|MFT_CENTER);
	CNewMenu* pMenu = DYNAMIC_DOWNCAST(CNewMenu,m_DefaultNewMenu.GetSubMenu(1));
	if(pMenu)
	{
		pMenu->SetMenuTitle(_T("New Menu Settings"),MFT_ROUND);
	}

	m_DefaultNewMenu.LoadToolBar(IDR_MAINFRAME);

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDialogDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CNewDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDialogDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
	int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CNewDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDialogDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CDialogDlg::OnNewMenuNextStyle() 
{
	int nStyle = AfxGetApp()->GetProfileInt(_T("NewMenu"),_T("Style"),2)+2;

	if(nStyle>CNewMenu::STYLE_ICY_NOBORDER)
		nStyle = CNewMenu::STYLE_ORIGINAL+(nStyle&1);

	int nActStyle = CNewMenu::GetMenuDrawMode();
	AfxGetApp()->WriteProfileInt(_T("NewMenu"),_T("Style"),nStyle);
	if(nActStyle!=nStyle)
	{
    // Subclass dialog with system menu
    CNewMenuHelper myHelper(NEW_MENU_DIALOG_SUBCLASS|NEW_MENU_DIALOG_SYSTEM_MENU);
		AfxMessageBox(_T("You must restart the application for changing the menu style"),MB_OK);
	}
}

void CDialogDlg::OnUpdateNewMenuNextStyle(CCmdUI* pCmdUI) 
{
	int nStyle = AfxGetApp()->GetProfileInt(_T("NewMenu"),_T("Style"),2);
	int nActStyle = CNewMenu::GetMenuDrawMode();
	pCmdUI->SetCheck(nStyle==nActStyle);
	switch(nStyle)
	{
	case CNewMenu::STYLE_ORIGINAL:
		pCmdUI->SetText(_T("Original new border"));
		break;

  case CNewMenu::STYLE_ORIGINAL_NOBORDER:
		pCmdUI->SetText(_T("Original old border"));
		break;

	case CNewMenu::STYLE_ICY:
		pCmdUI->SetText(_T("Icy new border"));
		break;

  case CNewMenu::STYLE_ICY_NOBORDER:
		pCmdUI->SetText(_T("Icy old border"));
		break;

  case CNewMenu::STYLE_XP:
		pCmdUI->SetText(_T("XP new border"));
		break;

  case CNewMenu::STYLE_XP_NOBORDER:
		pCmdUI->SetText(_T("XP old border"));
		break;

  case CNewMenu::STYLE_SPECIAL:
		pCmdUI->SetText(_T("Special new border"));
		break;

	case CNewMenu::STYLE_SPECIAL_NOBORDER:
		pCmdUI->SetText(_T("Special old border"));
		break;
	}
}

void CDialogDlg::OnNewMenuShowSelection() 
{
	BOOL bMode = CNewMenu::GetSelectDisableMode()?FALSE:TRUE;
	AfxGetApp()->WriteProfileInt(_T("NewMenu"),_T("Selection"),bMode);
	CNewMenu::SetSelectDisableMode(bMode);
}

void CDialogDlg::OnUpdateNewMenuShowSelection(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(CNewMenu::GetSelectDisableMode());
}

void CDialogDlg::OnNewMenuNormalBorder() 
{
	int nStyle = AfxGetApp()->GetProfileInt(_T("NewMenu"),_T("Style"),2);

	int nActStyle = CNewMenu::GetMenuDrawMode()&~1;
	CNewMenu::SetMenuDrawMode(nActStyle|((nStyle^1)&1));

	AfxGetApp()->WriteProfileInt(_T("NewMenu"),_T("Style"),nStyle^1);
}

void CDialogDlg::OnUpdateNewMenuNormalBorder(CCmdUI* pCmdUI) 
{
	pCmdUI->SetRadio(TRUE);
	if(CNewMenu::GetMenuDrawMode()&1)
	{
		pCmdUI->SetText(_T("Old border"));
	}
	else
	{
		pCmdUI->SetText(_T("New border"));
	}
}

void CDialogDlg::OnEditCut()
{
	m_Edit.Cut();
}

void CDialogDlg::OnEditCopy()
{
	m_Edit.Copy();
}

void CDialogDlg::OnEditPaste()
{
	m_Edit.Paste();
}

void CDialogDlg::OnEditClear()
{
	m_Edit.Clear();
}

void CDialogDlg::OnEditUndo()
{
	m_Edit.Undo();
}

void CDialogDlg::OnEditSelectAll()
{
	m_Edit.SetSel(0, -1);
}

void CDialogDlg::OnUpdateEditUndo(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(m_Edit.CanUndo());
}

void CDialogDlg::OnUpdateNeedSel(CCmdUI* pCmdUI)
{
	int nStartChar, nEndChar;
	m_Edit.GetSel(nStartChar, nEndChar);
	pCmdUI->Enable(nStartChar != nEndChar);
}

void CDialogDlg::OnUpdateNeedClip(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(::IsClipboardFormatAvailable(CF_TEXT));
}

void CDialogDlg::OnUpdateNeedText(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(m_Edit.GetWindowTextLength() != 0);
}
void CDialogDlg::OnBnClickedButton1()
{
	CNewMenu popupMenu, subMenu1, subMenu2;
	//CMenu popupMenu, subMenu1, subMenu2;
	popupMenu.CreatePopupMenu();	
	subMenu1.CreatePopupMenu();
	subMenu2.CreatePopupMenu();

	subMenu1.AppendMenu(MF_STRING, ID_EDIT_CUT, _T("Cut"));
	subMenu1.AppendMenu(MF_STRING, ID_EDIT_COPY, _T("Copy"));
	subMenu1.AppendMenu(MF_STRING, ID_EDIT_PASTE, _T("Paste"));
	popupMenu.AppendMenu(MF_POPUP, (UINT)subMenu1.m_hMenu, _T("Menu 1"));
	popupMenu.AppendMenu(MF_POPUP, (UINT)subMenu2.m_hMenu, _T("Menu 2"));
  //popupMenu.AppendODPopupMenu(_T("Test"));

  subMenu2.SetBitmapBackground(RGB(192,192,192));
  UINT nIDs[] = {IDB_FILE_A,IDB_FILE_B,IDB_FOLDER_A,IDB_FOLDER_B};
  for(int n=0;n<80;n++)
  {
    CString str;
    str.Format(_T("File Test %2ld"),n);
    subMenu2.InsertODMenu(n, str,MF_BYPOSITION , n+10000, nIDs[n&3]);
  }
  popupMenu.LoadToolBar(IDR_MAINFRAME);
  popupMenu.ModifyODMenu(0,_T("Menu 1"),IDB_MORE_A);
  popupMenu.ModifyODMenu(0,_T("Menu 2"),IDB_MORE_B);

	CRect rect;
  GetDlgItem(IDC_BUTTON1)->GetWindowRect(rect);

//  CNewMenu* pMenu = DYNAMIC_DOWNCAST(CNewMenu,CNewMenu::FindPopupMenuFromID(popupMenu,ID_EDIT_PASTE));
//  ASSERT(pMenu);
//  pMenu->SetItemData(ID_EDIT_PASTE,0x1234);
//
//  ASSERT(subMenu2.GetItemData(ID_EDIT_PASTE)==0x1234);

	popupMenu.TrackPopupMenu(TPM_LEFTALIGN | TPM_LEFTBUTTON,rect.left, rect.bottom, this);
}

void CDialogDlg::OnUpdateFileRange(CCmdUI* pCmdUI)
{
  pCmdUI->SetCheck(pCmdUI->m_nID&3);
  pCmdUI->Enable((pCmdUI->m_nID>>2)&1);
}

void CDialogDlg::OnNewMenuEnableGloom() 
{
  CNewMenu::SetXpBlendig(CNewMenu::GetXpBlendig()?FALSE:TRUE);
	AfxGetApp()->WriteProfileInt(_T("NewMenu"),_T("Gloom"),CNewMenu::GetXpBlendig());
}

void CDialogDlg::OnUpdateNewMenuEnableGloom(CCmdUI* pCmdUI) 
{
  if(CNewMenu::GetMenuDrawMode()==CNewMenu::STYLE_XP ||
     CNewMenu::GetMenuDrawMode()==CNewMenu::STYLE_XP_NOBORDER)
  {
    pCmdUI->Enable(TRUE);
  }
  else
  {
    pCmdUI->Enable(FALSE);
  }
  pCmdUI->SetCheck(CNewMenu::GetXpBlendig());
}


void CDialogDlg::OnNewMenuAllSameBorder()
{
  CNewMenu::SetNewMenuBorderAllMenu(CNewMenu::GetNewMenuBorderAllMenu()?FALSE:TRUE);
}

void CDialogDlg::OnUpdateNewMenuAllSameBorder(CCmdUI* pCmdUI)
{
  pCmdUI->SetCheck(CNewMenu::GetNewMenuBorderAllMenu());
}

