// DialogDlg.h : header file
//

#if !defined(AFX_DIALOGDLG_H__3022F845_79AE_4B5E_BB81_651ADB0A7F41__INCLUDED_)
#define AFX_DIALOGDLG_H__3022F845_79AE_4B5E_BB81_651ADB0A7F41__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "NewEdit.h"

/////////////////////////////////////////////////////////////////////////////
// CDialogDlg dialog

class CDialogDlg : public CNewDialog
{
// Construction
public:
	CDialogDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CDialogDlg)
	enum { IDD = IDD_DIALOG_DIALOG };
	CNewEdit	m_Edit;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDialogDlg)
	public:
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CDialogDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnNewMenuNextStyle();
	afx_msg void OnUpdateNewMenuNextStyle(CCmdUI* pCmdUI);
	afx_msg void OnNewMenuShowSelection();
	afx_msg void OnUpdateNewMenuShowSelection(CCmdUI* pCmdUI);
	afx_msg void OnNewMenuNormalBorder();
	afx_msg void OnUpdateNewMenuNormalBorder(CCmdUI* pCmdUI);
	afx_msg void OnNewMenuAllSameBorder();
	afx_msg void OnUpdateNewMenuAllSameBorder(CCmdUI* pCmdUI);
	//}}AFX_MSG
	afx_msg void OnUpdateNeedSel(CCmdUI* pCmdUI);
	afx_msg void OnUpdateNeedClip(CCmdUI* pCmdUI);
	afx_msg void OnUpdateNeedText(CCmdUI* pCmdUI);
	afx_msg void OnUpdateEditUndo(CCmdUI* pCmdUI);
	afx_msg BOOL OnEditChange();
	afx_msg void OnEditCut();
	afx_msg void OnEditCopy();
	afx_msg void OnEditPaste();
	afx_msg void OnEditClear();
	afx_msg void OnEditUndo();
	afx_msg void OnEditSelectAll();
	afx_msg void OnEditReplace();
  afx_msg void OnUpdateFileRange(CCmdUI* pCmdUI);
	afx_msg void OnNewMenuEnableGloom();
	afx_msg void OnUpdateNewMenuEnableGloom(CCmdUI* pCmdUI);
	DECLARE_MESSAGE_MAP()
public:
  afx_msg void OnBnClickedButton1();
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DIALOGDLG_H__3022F845_79AE_4B5E_BB81_651ADB0A7F41__INCLUDED_)
