// MDIFloatingView.h : interface of the CMDIFloatingView class
//


#pragma once


class CMDIFloatingView : public CEditView
{
protected: // create from serialization only
	CMDIFloatingView();
	DECLARE_DYNCREATE(CMDIFloatingView)

// Attributes
public:
	CMDIFloatingDoc* GetDocument() const;

// Operations
public:

// Overrides
	public:
virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);

// Implementation
public:
	virtual ~CMDIFloatingView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	DECLARE_MESSAGE_MAP()
public:
  afx_msg void OnContextMenu(CWnd* /*pWnd*/, CPoint /*point*/);
};

#ifndef _DEBUG  // debug version in MDIFloatingView.cpp
inline CMDIFloatingDoc* CMDIFloatingView::GetDocument() const
   { return reinterpret_cast<CMDIFloatingDoc*>(m_pDocument); }
#endif

