// PopupTestView.h : interface of the CPopupTestView class
//


#pragma once


class CPopupTestView : public CView
{
protected: // create from serialization only
	CPopupTestView();
	DECLARE_DYNCREATE(CPopupTestView)

// Attributes
public:
	CPopupTestDoc* GetDocument() const;

// Operations
public:

// Overrides
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);

// Implementation
public:
	virtual ~CPopupTestView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	DECLARE_MESSAGE_MAP()
public:
  afx_msg void OnContextMenu(CWnd* /*pWnd*/, CPoint /*point*/);

  // All these three function you have to implement
  afx_msg void OnMeasureItem(int nIDCtl, LPMEASUREITEMSTRUCT lpMIS);
  afx_msg LRESULT OnMenuChar(UINT nChar, UINT nFlags, CMenu* pMenu); 
  afx_msg void OnInitMenuPopup(CMenu* pPopupMenu, UINT nIndex, BOOL bSysMenu);
};

#ifndef _DEBUG  // debug version in PopupTestView.cpp
inline CPopupTestDoc* CPopupTestView::GetDocument() const
   { return reinterpret_cast<CPopupTestDoc*>(m_pDocument); }
#endif

