// NewEdit.cpp : implementation file
//

#include "stdafx.h"
#include "Dialog.h"
#include "NewEdit.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CNewEdit

CNewEdit::CNewEdit()
{
}

CNewEdit::~CNewEdit()
{
}


BEGIN_MESSAGE_MAP(CNewEdit, CEdit)
	//{{AFX_MSG_MAP(CNewEdit)
	ON_WM_CONTEXTMENU()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNewEdit message handlers

static CString GetShort(UINT id)
{
	CString str;
	str.LoadString(id);
	int nIndex = str.ReverseFind(_T('\n'));
	if(nIndex!=-1)
	{
		str=str.Mid(nIndex+1);
	}
	return str;
}

void CNewEdit::OnContextMenu(CWnd* pWnd, CPoint point) 
{
  UNREFERENCED_PARAMETER(pWnd);

  if(point.x==-1 && point.y==-1)
  {
    CRect rect;
    GetWindowRect(rect);

    point = rect.TopLeft()+CPoint(10,10);
  }
  SetFocus();

  CNewMenu menu;
  //CMenu menu;
  menu.CreatePopupMenu();
  menu.InsertMenu(0, MF_BYPOSITION , ID_EDIT_UNDO, GetShort(ID_EDIT_UNDO));
  menu.InsertMenu(1, MF_BYPOSITION|MF_SEPARATOR);
  menu.InsertMenu(2, MF_BYPOSITION , ID_EDIT_COPY, GetShort(ID_EDIT_COPY));
  menu.InsertMenu(2, MF_BYPOSITION , ID_EDIT_CUT, GetShort(ID_EDIT_CUT));
  menu.InsertMenu(4, MF_BYPOSITION , ID_EDIT_CLEAR, GetShort(ID_EDIT_CLEAR));
  menu.InsertMenu(5, MF_BYPOSITION , ID_EDIT_PASTE,  _T("&Paste") /* GetShort(ID_EDIT_PASTE) */);
  menu.InsertMenu(6, MF_BYPOSITION|MF_SEPARATOR);

  menu.InsertMenu(7, MF_BYPOSITION , ID_EDIT_SELECT_ALL,GetShort(ID_EDIT_SELECT_ALL));

  //// Code fragment I've added to put enough menu items into the popup menu
  //register int i;
  //for(i = 8; i < 58; i++)
  //{
  //    menu.InsertMenu(i, MF_BYPOSITION, ID_EDIT_PASTE, _T("&Paste"));
  //}
  //// End code fragment
  menu.SetMenuTitle(_T("Edit commands"),MFT_ROUND|MFT_CENTER/*|MFT_SIDE_TITLE*/);
  menu.LoadToolBar(IDR_MAINFRAME);

  menu.TrackPopupMenu(0x0010L | TPM_LEFTALIGN | TPM_LEFTBUTTON | TPM_RIGHTBUTTON, point.x, point.y, AfxGetMainWnd());
}
