// CntrItem.h : interface of the CSDICntrItem class
//

#if !defined(AFX_CNTRITEM_H__1CF2F154_C415_4A66_92BD_D6BA593BA18C__INCLUDED_)
#define AFX_CNTRITEM_H__1CF2F154_C415_4A66_92BD_D6BA593BA18C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CSDIDoc;
class CSDIView;

class CSDICntrItem : public CRichEditCntrItem
{
	DECLARE_SERIAL(CSDICntrItem)

// Constructors
public:
	CSDICntrItem(REOBJECT* preo = NULL, CSDIDoc* pContainer = NULL);
		// Note: pContainer is allowed to be NULL to enable IMPLEMENT_SERIALIZE.
		//  IMPLEMENT_SERIALIZE requires the class have a constructor with
		//  zero arguments.  Normally, OLE items are constructed with a
		//  non-NULL document pointer.

// Attributes
public:
	CSDIDoc* GetDocument()
		{ return (CSDIDoc*)CRichEditCntrItem::GetDocument(); }
	CSDIView* GetActiveView()
		{ return (CSDIView*)CRichEditCntrItem::GetActiveView(); }

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSDICntrItem)
	public:
	protected:
	//}}AFX_VIRTUAL

// Implementation
public:
	~CSDICntrItem();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CNTRITEM_H__1CF2F154_C415_4A66_92BD_D6BA593BA18C__INCLUDED_)
